dofile"./protocol/GB28181/Script/Lua/md5calc.lua"


local password = "12345678" --עʧܣ֮޸Ļ12345678ʹɹ
local RegisterTable = {}   --ڴעϢжǷˢע

function SipProcess(sipValue, parseRet)
	print("SipProcess[SipMethord] = "..sipValue["SipMethord"])
	local ret = false
	if sipValue["SipMethord"] == "REGISTER" then
		ret = handleRegister(sipValue, parseRet)
	elseif sipValue["SipMethord"] == "MESSAGE" then
		ret = handleMessage(sipValue, parseRet)
	elseif sipValue["SipMethord"] == "SIP" then
		ret = handleSIP(sipValue, parseRet)
	end
	return ret
end

function handleRegister(sipValue, parseRet)
	print("handleRegister +")
	if not sipValue["sipId"] then return false end
	if not sipValue["sipDomain"] then return false end
	if not sipValue["FromId"] then return false end
	if not sipValue["FromDomain"] then return false end
	if not sipValue["ToId"] then return false end
	if not sipValue["ToDomain"] then return false end
	if not sipValue["CallId"] then return false end
	if not sipValue["Via"] then return false end
	if not sipValue["SeqValue"] then return false end
	if not sipValue["SeqType"] then return false end
	if not sipValue["Expires"] then return false end

	--ȫֱעЧ	
	Expires = sipValue["Expires"]
	local bRegister = false
	local bWithAuth = false
	local bSuccess = false
	local registerType = nil
	
	if Expires ~= 0 then
		bRegister = true
		parseRet:pushCString("Period", 300)
	else
		parseRet:pushCString("Period", 0)
	end

	--жǷмȨ	
	if sipValue["username"] then
		bWithAuth = true
		if not sipValue["realm"] then return false end
		if not sipValue["nonce"] then return false end
		if not sipValue["uri"] then return false end
		if not sipValue["response"] then return false end
		if not sipValue["algorithm"] then return false end
	end
	
	--֤sip id
	if not checkSip(sipValue, parseRet) then 
		return false 
	end
	--֤uri
	if not checkURI(sipValue["FromId"], parseRet) then 
		return false 
	end
	local registerType = nil
	if bWithAuth then
		print("checkMd5+")
		bSuccess = checkMd5(sipValue, parseRet)
		print("checkMd5-")
		if bRegister then
			if bSuccess then
				registerType = "REGISTER" --ע֤ɹREGISTER
			else
				registerType = "REGISTER_FAILED" --ע֤ʧܣREGISTER_FAILED
				password = "12345678"   --ָ12345678
			end
		else
			if bSuccess then
				registerType = "UNREGISTER" --ע֤ɹUNREGISTER
			else
				registerType = "UNREGISTER_FAILED" --ע֤ʧܣUNREGISTER_FAILED
			end
		end
	else
		if bRegister then
			registerType = "REGISTER401" --עδ֤REGISTER401
		else
			registerType = "UNREGISTER401" --עδ֤UNREGISTER401
		end
	end
	parseRet:pushCString("Date", os.date("%Y-%m-%dT%H:%M:%S"))
	parseRet:pushCString("_type", registerType)
	parseRet:pushCString("DeviceID", sipValue["FromId"])
	parseRet:pushCString("DeviceDomain", sipValue["FromDomain"])
	
	for key in pairs(sipValue) do
		parseRet:pushCString(key, sipValue[key])
	end
	
	if registerType == "REGISTER" then
		
		if RegisterTable["CallId"] ~= sipValue["CallId"] then
			--ǵһע
			RegisterTable["Date"] = os.time();
			RegisterTable["CallId"] = sipValue["CallId"]
			parseRet:pushCString("Record_len", 0)
			
			--ڱʶǰͳƵ¼ͨ
			parseRet:pushCString("Record_Chanenel", "")
			
		else
			--ˢע
			local LastRegisterTime = ATLuaConfig:instance():getConfig("LastRegisterTime")
			LastRegisterTime = LastRegisterTime + 0
			timeStamp = os.time() - LastRegisterTime
			if timeStamp > 500 then
				print("REGISTER TIME = "..timeStamp.." is out of Expires")
				return false
			end
		end
		parseRet:pushCString("LastRegisterTime", os.time())
	end
	print("_type = "..registerType)
	
	print("handleRegister - ")
	return true
end

function handleMessage(sipValue, parseRet)
	print("handleMessage +")
	if not sipValue["FromId"] then return false end
	if not sipValue["FromDomain"] then return false end
	if not sipValue["ToId"] then return false end
	if not sipValue["ToDomain"] then return false end
	if not sipValue["CallId"] then return false end
	if not sipValue["SeqValue"] then return false end
	if not sipValue["SeqType"] then return false end
	if not sipValue["ContentLength"] then return false end
	if not sipValue["ContentType"] then return false end
	
	for key in pairs(sipValue) do
		parseRet:pushCString(key, sipValue[key])
	end
	print("handleMessage -")
	return true
end

function handleSIP(sipValue, parseRet)
	print("handleSIP +")
	if not sipValue["SipStaus"] then return false end
	if not sipValue["FromId"] then return false end
	if not sipValue["FromDomain"] then return false end
	if not sipValue["ToId"] then return false end
	if not sipValue["ToDomain"] then return false end
	if not sipValue["CallId"] then return false end
	if not sipValue["SeqValue"] then return false end
	if not sipValue["SeqType"] then return false end
	
	rsptype = sipValue["SeqType"].."-"..sipValue["SipStaus"]
	print("_type = "..rsptype)
	parseRet:pushCString("_type", rsptype)
	
	for key in pairs(sipValue) do
		parseRet:pushCString(key, sipValue[key])
	end
	
	--ڻỰýϢҪһβ
	if sipValue["SeqType"] == "INVITE" and sipValue["SipStaus"] + 0 == 200 then
		parseRet:pushCString("CallFromTag", sipValue["ToTag"]) --Żȫֱ
	end
	print("handleSIP -")
	return true
end

	--֤Sip URI
function checkSip(sipValue, parseRet)

	local sipServerID = ATLuaConfig:instance():getConfig("SipID")
	if sipServerID ~= sipValue["sipId"] then return false end
	
	if not string.match(sipValue["sipDomain"], "%:") then
		if sipValue["sipDomain"] ~= ATLuaConfig:instance():getConfig("SipDomain") then
			print("checkSip error!")
			return false
		end
	else	--sip uriIP+Portʽ֤ 		
		local index	= string.find(sipValue["sipDomain"], ":")
		local registerIp = string.sub(sipValue["sipDomain"], 1, index-1)
		local registerPort = string.sub(sipValue["sipDomain"], index+1, -1)
		if registerIp ~= ATLuaConfig:instance():getConfig("@_LOCAL_IP") or 
			registerPort ~= ATLuaConfig:instance():getConfig("@_Net_SIPPort") then
			print("checkSip error!")
			return false
		end
	end
	return true
end

function checkURI(FromId, parseRet)
	local deviceType = ATLuaConfig:instance():getConfig("GB_DeviceType")
	--ȡFromIDĵʮһλʮλ
	subType = string.sub(FromId, 11, 13)
	if "IPC" == deviceType and subType == "111" then
		return true
	end
	if "DVR" == deviceType and subType == "111" then
		return true
	end
	if "NVR" == deviceType and subType == "118" then
		return true
	end
		return false
end

function printSip(sipValue)
	for key in pairs(sipValue) do
		print("sipValue["..key.."] = "..sipValue[key])
	end
end

function md5Response(realm, user, password, nonce, url)
	local A1 = user..":"..realm..":"..password
	local A2 = "REGISTER"..":"..url
	local ret
	local ret1 = md5.Calc(A1)..":"..nonce..":"..md5.Calc(A2)
	ret = md5.Calc(ret1)
	return ret
end

function checkMd5(sipValue, parseRet)

	local realm = ATLuaConfig:instance():getConfig("realm")
	local nonce = ATLuaConfig:instance():getConfig("nonce")
	local genResponse = md5Response(realm, sipValue["username"], password, nonce, sipValue["uri"])

	if genResponse~= sipValue["response"] then
		print("genResponse = "..genResponse)
		print("recvResponse = "..sipValue["response"])
		return false
	end
	return true
end



